Skip to main content
POST
/
crm
/
v3
/
pipelines
/
{objectType}
Create a pipeline
curl --request POST \
  --url https://api.hubapi.com/crm/v3/pipelines/{objectType} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "displayOrder": 0,
  "label": "My replaced pipeline",
  "stages": [
    {
      "displayOrder": 0,
      "label": "In Progress",
      "metadata": {
        "ticketState": "OPEN"
      }
    },
    {
      "displayOrder": 1,
      "label": "Done",
      "metadata": {
        "ticketState": "CLOSED"
      }
    }
  ]
}
'
import requests

url = "https://api.hubapi.com/crm/v3/pipelines/{objectType}"

payload = {
"displayOrder": 0,
"label": "My replaced pipeline",
"stages": [
{
"displayOrder": 0,
"label": "In Progress",
"metadata": { "ticketState": "OPEN" }
},
{
"displayOrder": 1,
"label": "Done",
"metadata": { "ticketState": "CLOSED" }
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
displayOrder: 0,
label: 'My replaced pipeline',
stages: [
{displayOrder: 0, label: 'In Progress', metadata: {ticketState: 'OPEN'}},
{displayOrder: 1, label: 'Done', metadata: {ticketState: 'CLOSED'}}
]
})
};

fetch('https://api.hubapi.com/crm/v3/pipelines/{objectType}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "archived": false,
  "createdAt": "2019-10-30T03:30:17.883Z",
  "displayOrder": 0,
  "id": "812723471",
  "label": "My ticket pipeline",
  "stages": [
    {
      "archived": false,
      "createdAt": "2019-10-30T03:30:17.883Z",
      "displayOrder": 0,
      "id": "1234912",
      "label": "In Progress",
      "metadata": {
        "ticketState": "OPEN"
      },
      "updatedAt": "2019-12-07T16:50:06.678Z"
    },
    {
      "archived": false,
      "createdAt": "2019-10-30T03:30:17.883Z",
      "displayOrder": 0,
      "id": "1234914",
      "label": "Done",
      "metadata": {
        "ticketState": "CLOSED"
      },
      "updatedAt": "2019-12-07T16:50:06.678Z"
    }
  ],
  "updatedAt": "2019-12-07T16:50:06.678Z"
}
{
"message": "Invalid input (details will vary based on the error)",
"correlationId": "aeb5f871-7f07-4993-9211-075dc63e7cbf",
"category": "VALIDATION_ERROR",
"links": {
"knowledge-base": "https://www.hubspot.com/products/service/knowledge-base"
}
}

Supported products

Authorizations

Authorization
string
header
required

The access token received from the authorization server in the OAuth 2.0 flow.

Path Parameters

objectType
string
required

Body

application/json

An input used to create or replace a pipeline's definition.

displayOrder
integer<int32>
required

The order for displaying this pipeline. If two pipelines have a matching displayOrder, they will be sorted alphabetically by label.

label
string
required

A unique label used to organize pipelines in HubSpot's UI

stages
object[]
required

Pipeline stage inputs used to create the new or replacement pipeline.

pipelineId
string

Response

successful operation

A pipeline definition.

archived
boolean
required

Whether the pipeline is archived.

createdAt
string<date-time>
required

The date the pipeline was created. The default pipelines will have createdAt = 0.

displayOrder
integer<int32>
required

The order for displaying this pipeline. If two pipelines have a matching displayOrder, they will be sorted alphabetically by label.

id
string
required

A unique identifier generated by HubSpot that can be used to retrieve and update the pipeline.

label
string
required

A unique label used to organize pipelines in HubSpot's UI

stages
object[]
required

The stages associated with the pipeline. They can be retrieved and updated via the pipeline stages endpoints.

updatedAt
string<date-time>
required

The date the pipeline was last updated.

archivedAt
string<date-time>

The date the pipeline was archived. archivedAt will only be present if the pipeline is archived.

Last modified on March 30, 2026